from websockets import connect, ConnectionClosed
from requests import post
from crypto import Crypto
from random import choice
from json import dumps, loads

_data = {"api_version": "5","auth": None,"method": "handShake"}

class WebSocket:

    def __init__(self, auth):

        self.__auth__ = auth

        self.__ws_servers__ = post("https://getdcmess.iranlms.ir/").json()["data"]["socket"].values()

        self.__encrypt__ = Crypto(auth)

        _data["auth"] = auth

        del auth

    async def hand_snake(self,):

        wss = choice(list(self.__ws_servers__))

        async for websocket in connect(wss):
            try:

                await websocket.send(dumps(_data))

                while True:

                    data = await websocket.recv()

                    if data != '{"status":"OK"':

                        yield loads(data,)

                    else: continue

            except ConnectionClosed: continue

    async def handler(self):

        async for message in self.hand_snake():

            if message.get('type') == 'messenger': 
                
                yield loads(self.__encrypt__.decode(message.get('data_enc')))