from crypto import Crypto
from json import dumps, loads
from urllib3 import PoolManager
import aiohttp

class Clients:

    web = {
        'app_name': 'Main',
        'app_version': '4.1.7',
        'platform': 'Web',
        'package': 'web.rubika.ir',
        'lang_code': 'fa'
    }

    android = {
        'app_name': 'Main',
        'app_version': '3.0.7',
        'platform': 'Android',
        'package': 'ir.resaneh1.iptv',
        'lang_code': 'fa'
    }

class Maker:

    def __init__(self, auth):

        self.auth = auth

        self.encrypt = Crypto(auth)

        del auth

    async def method(self, method, data, Client = 1, type = 5):
        
        if type == 5:

            data = {
                "api_version": str(type),
                "auth": self.auth,
                "data_enc": self.encrypt.encode(
                    dumps(
                        {
                            "method": method,
                            "input": data,
                            "client": Clients.web if Client == 1 else Clients.android
                        }
                    )
                )
            }

        else:

            data = {
                "api_version": type,
                "auth": self.auth,
                "client": Clients.android,
                "method": method,
                "data_enc": self.encrypt.encode(dumps(data))
            }

        while True:

            async with aiohttp.ClientSession() as result:
                async with result.post('https://messengerg2c2.iranlms.ir/',
                json = data) as result:

                    if result.status == 200:

                        result = loads(self.encrypt.decode((await result.json())["data_enc"]))

                        status = result["status"]

                        if status == "OK":

                            return result

                        elif status in ["ERROR_GENERIC", "ERROR_ACTION"]:

                            for i in [
                                ("INVALID_AUTH", "Auth Key account shoma na moatabar ast !"),
                                ("INVALID_INPUT", "Vorudi method na moatabar ast !"),
                                ("NOT_REGISTERED", "Auth Key account shoma na moatabar ast !"),
                                ("TOO_REQUESTS", "Darkhast bish az had !")
                            ]:

                                if result["status_det"] == i[0]:

                                    raise IndexError(i[1])

                            else:

                                raise IndexError(result)
                    
                    elif result.status == 502:
                        
                        continue

                    else:

                        raise IndexError(result.data.decode('UTF-8'))