from re import findall

class Message:

    def __init__(self, message):

        self.msg = message

    async def data(self):

        return self.msg

    async def guid(self):

        return self.msg["message_updates"][0].get("object_guid", "None")

    async def message_id(self):

        return self.msg["message_updates"][0].get("message_id", "None")

    async def action(self):

        return self.msg["message_updates"][0].get("action", "None")

    async def text(self):

        return self.msg["message_updates"][0]["message"].get("text", "None")

    async def send_time(self):

        return self.msg["message_updates"][0]["message"].get("time", "None")

    async def is_edited(self):

        return self.msg["message_updates"][0]["message"].get("is_edited", "None")

    async def message_type(self):

        return self.msg["message_updates"][0]["message"].get("type", "None")

    async def author_type(self):

        return self.msg["message_updates"][0]["message"].get("author_type", "None")

    async def author_guid(self):

        return self.msg["message_updates"][0]["message"].get("author_object_guid", "None")

    async def is_user_chat(self):

        return self.msg["message_updates"][0].get("type", "None") == "User"

    async def is_group_chat(self):

        return self.msg["message_updates"][0].get("type", "None") == "Group"

    async def is_channel_chat(self):

        return self.msg["message_updates"][0].get("type", "None") == "Channel"

    async def title(self):

        return self.msg["show_notifications"][0].get("title", "None")

    async def author_title(self):

        return self.msg["show_notifications"][0].get("text", "None:Text").split(":")[0] if await self.is_group_chat() else await self.title()


class Tool:

    def text_parser(text, guid = None):
        results = []
        real_text = text.replace('**', '').replace('__', '').replace('``', '').replace('@@', '')
        bolds = findall(r'\*\*(.*?)\*\*', text)
        italics = findall(r'\_\_(.*?)\_\_', text)
        monos = findall(r'\`\`(.*?)\`\`', text)
        mentions = findall(r'\@\@(.*?)\@\@', text)
        monos_result = [real_text.index(i) for i in monos]
        bolds_result = [real_text.index(i) for i in bolds]
        italics_result = [real_text.index(i) for i in italics]
        mentions_result = [real_text.index(i) for i in mentions]

        for bIndex, bWord in zip(bolds_result, bolds):
            results.append({
				'from_index' : bIndex,
				'length' : len(bWord),
				'type' : 'Bold'
			})

        for iIndex, iWord in zip(italics_result, italics):
            results.append({
				'from_index' : iIndex,
				'length' : len(iWord),
				'type' : 'Italic'
			})

        for mIndex, mWord in zip(monos_result, monos):
            results.append({
				'from_index' : mIndex,
				'length' : len(mWord),
				'type' : 'Mono'
			})

        for menIndex, menWord in zip(mentions_result, mentions):
            results.append({
				'from_index' : menIndex,
				'length' : len(menWord),
				'type' : 'MentionText',
                "mention_text_object_guid": guid
			})

        return (results, real_text)